Name:          atmosphere
Version:       2.4.7
Release:       1%{?dist}
Summary:       Real-time Client Server Framework for the JVM
License:       ASL 2.0 and CDDL
URL:           http://async-io.org/
Source0:       https://github.com/Atmosphere/atmosphere/archive/%{name}-project-%{version}.tar.gz
Patch0:        atmosphere-2.4.7-port-atmosphere-runtime-to-servlet3.1.patch
# Remove GlassFishv2, Grizzly1, JBoss5, JBossWeb, Jetty6, Tomcat6,7, WebLogic support
Patch1:        atmosphere-2.4.7-remove-unavailable-containers-support.patch

BuildRequires: maven-local
BuildRequires: mvn(javax.enterprise:cdi-api)
BuildRequires: mvn(javax.inject:javax.inject)
BuildRequires: mvn(javax.servlet:javax.servlet-api)
BuildRequires: mvn(javax.websocket:javax.websocket-api)
BuildRequires: mvn(org.apache.commons:commons-pool2)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.maven.shared:maven-filtering)
BuildRequires: mvn(org.apache.shiro:shiro-core)
BuildRequires: mvn(org.apache.shiro:shiro-web)
BuildRequires: mvn(org.eclipse.jetty:jetty-continuation:8.1)
BuildRequires: mvn(org.eclipse.jetty:jetty-io)
BuildRequires: mvn(org.eclipse.jetty:jetty-util)
BuildRequires: mvn(org.eclipse.jetty:jetty-websocket:8.1)
BuildRequires: mvn(org.eclipse.jetty.websocket:websocket-server)
BuildRequires: mvn(org.glassfish.grizzly:grizzly-comet)
BuildRequires: mvn(org.glassfish.grizzly:grizzly-websockets)
BuildRequires: mvn(org.glassfish.grizzly:grizzly-http-servlet)
BuildRequires: mvn(org.jboss:jboss-vfs)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.sonatype.oss:oss-parent:pom:)

# Test deps
# BuildRequires: mvn(ch.qos.logback:logback-classic)
# BuildRequires: mvn(ch.qos.logback:logback-core)
# BuildRequires: mvn(com.ning:async-http-client)
# BuildRequires: mvn(org.mockito:mockito-all)
# BuildRequires: mvn(org.slf4j:jcl-over-slf4j)
# BuildRequires: mvn(org.slf4j:jul-to-slf4j)
# BuildRequires: mvn(org.testng:testng)

BuildArch:     noarch

%description
The Atmosphere Framework contains client and server side components
for building Asynchronous Web Applications. The majority of popular
frameworks are either supporting Atmosphere or supported natively
by the framework. The Atmosphere Framework supports all major
Browsers and Servers.

%package annotations
Summary:       Atmosphere Framework Annotations

%description annotations
Atmosphere Framework Annotations.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%package modules
Summary:       Atmosphere Framework Modules Parent POM

%description modules
Atmosphere Framework Modules Parent POM.

%package project
Summary:       Atmosphere Framework Project Parent POM

%description project
Atmosphere Framework Project Parent POM.

%prep
%setup -q -n %{name}-%{name}-project-%{version}
%patch0 -p1
%patch1 -p1

%pom_disable_module assembly
%pom_disable_module buildtools
%pom_disable_module jersey modules
%pom_disable_module native modules

# Unneeded tasks
%pom_remove_plugin :maven-checkstyle-plugin
%pom_remove_plugin :maven-pmd-plugin
%pom_remove_plugin :maven-site-plugin
%pom_remove_plugin :maven-release-plugin
%pom_remove_plugin :maven-clean-plugin

%pom_remove_dep -r org.atmosphere:atmosphere-compat-jbossweb
%pom_remove_dep -r org.atmosphere:atmosphere-compat-tomcat
%pom_remove_dep -r org.atmosphere:atmosphere-compat-tomcat7
%pom_remove_dep -r org.atmosphere:atmosphere-stubs
%pom_remove_dep -r org.atmosphere.jboss.as:jboss-as-websockets
rm modules/cpr/src/main/java/org/atmosphere/container/JBoss*.java \
 modules/cpr/src/main/java/org/atmosphere/container/version/JBoss*.java
# package weblogic.websocket does not exist
rm modules/cpr/src/main/java/org/atmosphere/container/Weblogic*.java \
 modules/cpr/src/main/java/org/atmosphere/container/version/WebLogic*.java
 
# tomcat:7.0.35
%pom_remove_dep -r org.apache.tomcat:
rm modules/cpr/src/main/java/org/atmosphere/container/Tomcat*.java \
 modules/cpr/src/main/java/org/atmosphere/container/version/Tomcat*.java

# grizzly:1.0.31,1.9.57
%pom_remove_dep -r com.sun.grizzly:
rm modules/cpr/src/main/java/org/atmosphere/container/GrizzlyCometSupport.java \
 modules/cpr/src/main/java/org/atmosphere/container/GlassFishv2CometSupport.java \
 modules/cpr/src/main/java/org/atmosphere/container/GrizzlyServlet30WebSocketSupport.java \
 modules/cpr/src/main/java/org/atmosphere/container/GlassFishServlet30WebSocketSupport.java \
 modules/cpr/src/main/java/org/atmosphere/container/GlassFishWebSocketHandler.java \
 modules/cpr/src/main/java/org/atmosphere/container/GlassFishWebSocketSupport.java \
 modules/cpr/src/main/java/org/atmosphere/container/version/GrizzlyWebSocket.java

# jetty:6.1.22
%pom_remove_dep -r org.mortbay.jetty:
# jetty:7.6.9.v20130131
%pom_change_dep -r :jetty-continuation ::8.1
%pom_change_dep -r :jetty-websocket ::8.1
rm modules/cpr/src/main/java/org/atmosphere/container/JettyCometSupport.java

%pom_change_dep -r javax:javaee-api javax.inject:javax.inject:1
%pom_add_dep javax.enterprise:cdi-api:1.2 modules/cpr

%pom_change_dep -r :geronimo-servlet_3.0_spec javax.servlet:javax.servlet-api:3.1.0

%build

%mvn_build -sf

%install
%mvn_install

%files -f .mfiles-atmosphere-runtime
%doc ATMOSPHERE_3_ROADMAP.md CHANGELOG.md README.md
%license license/*

%files annotations -f .mfiles-atmosphere-annotations

%files javadoc -f .mfiles-javadoc
%license license/*

%files modules -f .mfiles-atmosphere-modules
%license license/*

%files project -f .mfiles-atmosphere-project
%license license/*

%changelog
* Sun Sep 25 2016 gil cattaneo <puntogil@libero.it> 2.4.7-1
- update to 2.4.7

* Tue Sep 20 2016 gil cattaneo <puntogil@libero.it> 2.4.6-1
- initial rpm

